public without sharing class TV_LCC_Util_LegalText { 

    class LegalTextException extends Exception {}

    public static final String C = '**';

    public static final Decimal IVA = 1.21;
    public static final Decimal IGIC = 1.03;
    public static final Decimal IPSI = 1.01;
    public static final Decimal ELECTRICITY_TAX = 1.0511269632;
    public static final Decimal GAS_TAX = 0.00234;

    @AuraEnabled
    public static LegalTextWrapper getLegalTextAndUrlConga(Id caseId){
        LegalTextWrapper response = new LegalTextWrapper();
        try{
            String legalText = getLegalText(caseId);
            Id temporalRecord = createTemporalRecord(caseId, legalText);
            response.legalText = legalText;
            response.urlCongaPDF = getUrlConga(caseId, temporalRecord);
            response.error = '';
        }catch(Exception e){
            response.legalText = '';
            response.urlCongaPDF = '';
            response.error = e.getMessage();
        }
        return response;
    }
     
    // 5003N0000057PLlQAM
    public static String getLegalText(Id caseId){

        if( !Schema.sObjectType.NE__OrderItem__c.isAccessible()
            || !Schema.sObjectType.AccountContactRelation.isAccessible()
            || !Schema.sObjectType.FI_CongaParametrization__c.isAccessible()
            || !Schema.sObjectType.Asset.isAccessible()
            || !Schema.sObjectType.NE__Order_Item_Attribute__c.isAccessible()
            || !Schema.sObjectType.TV_LegalTextGeneric__c.isAccessible()
            || !Schema.sObjectType.TV_LegalTextProduct__c.isAccessible()){
            throw new LegalTextException('Error al generar Texto Legal. Configuración incorrecta: No hay permiso para alguno de los objectos necesarios');   
        }
        

        List<NE__OrderItem__c> listCIs =    [SELECT    
                                                Id,
                                                FI_CI_FLG_Quota12__c,
                                                FI_CI_NUM_PowerToHire1kW__c,
                                                FI_CI_NUM_PowerToHire2kW__c,
                                                FI_CI_NUM_PowerToHire3kW__c,
                                                TOLABEL(FI_CI_SEL_Subtype__c),
                                                TOLABEL(FI_CI_SEL_Current_ATR_Rate__c),
                                                TOLABEL(FI_CI_SEL_RateATRTollGroup__c ),
                                                FI_CI_LKP_CUPS__r.PostalCode__c,
                                                NE__ProdId__r.FI_CMP_FLG_Allowed_Price_Annex__c,
                                                NE__Parent_Order_Item__c,
                                                FI_CMP_SEL_Commodity__c,
                                                FI_CI_SEL_Business_Line__c,
                                                FI_CI_TXT_Product_number__c,
                                                NE__ProdName__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_Campaign__r.Campaignsubtype__c,
                                                FI_CI_LKP_PaytmenDatas__r.IBAN__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.Id,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.Name,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.Adress__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.PostalCode__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.Business_line_cd__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.CNAE__r.Segment__c,
                                                TOLABEL(FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.DistribuitorElec_cd__c),
                                                TOLABEL(FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.DistribuitorGas_cd__c),
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.AddrId_Id__r.Id,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.Id,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.Name,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.AddrId_Id__r.Id,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.Adress__c, 
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.PostalCode__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.Business_line_cd__c,
                                                FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.CNAE__r.Segment__c,
                                                TOLABEL(FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.DistribuitorElec_cd__c),
                                                TOLABEL(FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.DistribuitorGas_cd__c),
                                                FI_CI_LKP_Quote__r.FI_NEQ_FLG_Digital_Invoice_Quote__c,
                                                FI_CI_LKP_Quote__r.Case__r.Account.Id,
                                                FI_CI_LKP_Quote__r.Case__r.AccountId,
                                                FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r.Id,
                                                FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r.FirstName,
                                                FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r.LastName,
                                                FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r.NIF_CIF_Customer_NIE__c,
                                                FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r.MobilePhone,
                                                FI_CI_LKP_Quote__r.Case__r.Contact.FirstName,
                                                FI_CI_LKP_Quote__r.Case__r.Contact.LastName,
                                                FI_CI_LKP_Quote__r.Case__r.Contact.NIF_CIF_Customer_NIE__c,
                                                FI_CI_LKP_Quote__r.Case__r.Contact.MobilePhone,
                                                FI_CI_LKP_Quote__r.Case__r.Contact.Physical_or_legal_cd__c,
                                                FI_CI_LKP_Quote__r.Case__r.FII_CAS_LKP_Campaign__r.Campaignsubtype__c, 
                                                (SELECT Id, NE__ProdName__c, FI_CI_TXT_Product_number__c FROM NE__Parent_Order_Item__r)
                                            FROM NE__OrderItem__c WHERE 
                                                FI_CI_LKP_Quote__r.Case__c = :caseId
                                                AND NE__Parent_Order_Item__c = null
                                                AND NE__Status__c = 'Pending'
                                                AND FI_CI_SEL_Type__c IN ('A', 'M')
                                            ORDER BY FI_CMP_SEL_Commodity__c, FI_CI_SEL_Business_Line__c];
        if(listCIs.isEmpty()){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun ci.');
        }
        Account account = listCIs[0].FI_CI_LKP_Quote__r.Case__r.Account;
        Contact titularContact = listCIs[0].FI_CI_LKP_Quote__r.Case__r.Account.TitularContactHide__r;
        Contact authorizedContact = listCIs[0].FI_CI_LKP_Quote__r.Case__r.Contact;

        List<AccountContactRelation> listRoles = [SELECT ContactId, Roles FROM AccountContactRelation WHERE AccountId = :account.Id AND ContactId =:authorizedContact.Id];
        if(listRoles.isEmpty()){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun rol para este contacto en este cliente.');
        }
        AccountContactRelation role = listRoles[0]; 
        
        // Obtener lista de CODIGOS DE PRODUCTOS de los CIs padres
        List<FI_CongaParametrization__c> listPriceAnnexAttributes = [SELECT Name, 
                                                                            FI_COP_TXT_Conga_Code__c, 
                                                                            FI_COP_TXT_Conga_Real_Name__c,  
                                                                            FI_COP_TXT_Conga_Commercial_Name__c, 
                                                                            FI_COP_DAT_Conga_Start_Date__c 
                                                                    FROM FI_CongaParametrization__c 
                                                                    WHERE FI_COP_NUM_Conga_Component_Sequence__c != NULL 
                                                                        AND FI_COP_SEL_Conga_Language__c = 'Español'
                                                                        AND FI_COP_TXT_Conga_Code__c != NULL
                                                                        AND FI_COP_TXT_Conga_Real_Name__c NOT IN ('DIA', 'HORAS', 'Tipo Calendario', 'Más opciones')
                                                                        AND FI_COP_DAT_Conga_Start_Date__c <= :Date.today()];
        Set<String> setProductCodesWithAnnex = new Set<String>();
        for(NE__OrderItem__c ci: listCIs){
            if(ci.NE__ProdId__r.FI_CMP_FLG_Allowed_Price_Annex__c){
                setProductCodesWithAnnex.add(ci.FI_CI_TXT_Product_number__c);
            }
        }
        
        Map<String, Map<String, FI_CongaParametrization__c>> mapProductCodePriceAttributes = new Map<String, Map<String, FI_CongaParametrization__c>>();
        for(String productCode : setProductCodesWithAnnex){
            Map<String, FI_CongaParametrization__c> mapPriceAttributes = new Map<String, FI_CongaParametrization__c>();
            for(FI_CongaParametrization__c priceAttribute : listPriceAnnexAttributes){
                if(priceAttribute.FI_COP_TXT_Conga_Code__c.contains(productCode)){
                    mapPriceAttributes.put(priceAttribute.FI_COP_TXT_Conga_Real_Name__c, priceAttribute);
                }
            }
            if(mapPriceAttributes.isEmpty()){
                throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun anexo de precio para el Código de producto: ' + productCode);
            }
            mapProductCodePriceAttributes.put(productCode, mapPriceAttributes);
        }

        // Usado en INICIO
        Boolean isRecoveryCampaign = false; 
        if(listCIs[0].FI_CI_LKP_Quote__r.FI_NEQ_LKP_Campaign__c != null && listCIs[0].FI_CI_LKP_Quote__r.FI_NEQ_LKP_Campaign__r.Campaignsubtype__c == 'Recovery'){
            isRecoveryCampaign = true; 
        }

        // Usado en INICIO, DISTRIBUIDORA, DERECHOS_ENDESA
        String contactPerson = '';
        if(authorizedContact.Physical_or_legal_cd__c == 'Physical Customer'){
            contactPerson = 'NIF';
        }else if(authorizedContact.Physical_or_legal_cd__c == 'Corportate Customer'){
            contactPerson = 'CIF';
        }

        // Usado en PERSONA
        String contactType = ''; 
        if(role.Roles == 'Autorizado'){
            contactType = 'AUTORIZADO';
        }else if(role.Roles== 'Titular de contrato'){
            contactType = 'TITULAR';
        }

        // Usado en FIN_OFERTA
        Boolean isContractingElec = false;
        Boolean isContractingGas = false;
        for(NE__OrderItem__c ci: listCIs){
            if(ci.NE__Parent_Order_Item__c  == null){
                if(ci.FI_CI_SEL_Business_Line__c == '01'){
                    isContractingElec = true;
                }else if(ci.FI_CI_SEL_Business_Line__c == '02'){
                    isContractingGas = true;
                }
            }
        }

        // Usado en EFACTURA
        String eInvoice = 'NO';
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_LKP_Quote__r.FI_NEQ_FLG_Digital_Invoice_Quote__c){
                eInvoice = 'SI';
            }
        }

        // Usado para mostrar SPP
        Set<String> setSPPCodes = new Set<String>{'AAON2','SPPW3','SPHEW'};
        Boolean hasSPP = false;
        for(NE__OrderItem__c ci: listCIs){
            if(setSPPCodes.contains(ci.FI_CI_TXT_Product_number__c)){
                hasSPP =  true;
            }
        }

        // Usado para mostrar CUOTADOCE
        Boolean hasQuote12 = false;
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_FLG_Quota12__c){
                hasQuote12 =  true;
            }
        }

        // Usado para mostrar FACTURACION
        Boolean hasDH = false;
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_SEL_RateATRTollGroup__c  != null && ci.FI_CI_SEL_RateATRTollGroup__c .contains('DH')){
                hasDH = true;
            }
        }

        // Usado para mostrar PUNTO_SUMINISTRO
        B2C_Service_Point__c spElec;
        B2C_Service_Point__c spGas;
        B2C_Address__c address;
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__c != null){
                spElec = ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r;
                address = ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Electric__r.AddrId_Id__r;
            }
            if(ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__c != null){
                spGas = ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r;
                address = ci.FI_CI_LKP_Quote__r.FI_NEQ_LKP_CUPS_Gas__r.AddrId_Id__r;
            }
        }
        if(spElec == null && spGas == null){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun Punto de Suministro asociado a la oferta.');
        }

        // Usado para saber si se esta DUALIZANDO
        List<Asset> listAssets = [SELECT Id,FI_ASS_SEL_BusinessLine__c FROM Asset WHERE FI_ASS_LKP_Address__c = :address.Id AND Status = 'Active'];
        Boolean hasElec = false;
        Boolean hasGas = false;
        for(Asset asset : listAssets){
            if(asset.FI_ASS_SEL_BusinessLine__c == '01'){
                hasElec = true;
            }else if(asset.FI_ASS_SEL_BusinessLine__c == '02'){
                hasGas = true;
            }
        }

        
        List<NE__OrderItem__c> listAllCIs   = new List<NE__OrderItem__c>();
        for(NE__OrderItem__c ci: listCIs){
            listAllCIs.add(ci);
            for(NE__OrderItem__c childCI : ci.NE__Parent_Order_Item__r){
                listAllCIs.add(childCI);
            }
        }
        List<NE__Order_Item_Attribute__c> listciAttributes = [  SELECT    
                                                                    Id, 
                                                                    Name,
                                                                    NE__Value__c,
                                                                    NE__Order_Item__c
                                                                FROM NE__Order_Item_Attribute__c 
                                                                WHERE NE__Order_Item__c IN :listAllCIs];

        Map<Id, List<NE__Order_Item_Attribute__c>> mapOrderItemAttributes = new Map<Id, List<NE__Order_Item_Attribute__c>>();
        for(NE__Order_Item_Attribute__c ciAttribute : listciAttributes){
            List<NE__Order_Item_Attribute__c> tempListciAttributes;
            if(mapOrderItemAttributes.containsKey(ciAttribute.NE__Order_Item__c)){
                tempListciAttributes = mapOrderItemAttributes.get(ciAttribute.NE__Order_Item__c);
            }else{
                tempListciAttributes = new List<NE__Order_Item_Attribute__c>();
            }
            tempListciAttributes.add(ciAttribute);
            mapOrderItemAttributes.put(ciAttribute.NE__Order_Item__c, tempListciAttributes);
        }           

        List<NE__OrderItem__c> listLuzCIs   = new List<NE__OrderItem__c>();
        List<NE__OrderItem__c> listGasCIs   = new List<NE__OrderItem__c>();
        List<NE__OrderItem__c> listNoECIs   = new List<NE__OrderItem__c>();
        List<NE__OrderItem__c> setAbonoCIs = new List<NE__OrderItem__c>();
        for(NE__OrderItem__c ci: listCIs){
            for(NE__OrderItem__c childCI : ci.NE__Parent_Order_Item__r){
                if(hasAttribute(mapOrderItemAttributes.get(childCI.Id), 'Código Abono CRM')){
                    setAbonoCIs.add(childCI);
                }
            }
           
            if(ci.FI_CMP_SEL_Commodity__c == 'Luz'){
                listLuzCIs.add(ci);
            }else if(ci.FI_CMP_SEL_Commodity__c == 'Gas'){
                listGasCIs.add(ci);
            }else{
                listNoECIs.add(ci);
            }
            
        }                                    
        
        List<TV_LegalTextGeneric__c> listGenericTexts = [SELECT 
                                                    Id, 
                                                    TV_LTG_SEL_Type__c,
                                                    TV_LTG_SEL_Subtype__c,
                                                    TV_LTG_TXT_Text__c,
                                                    TV_LTG_NUM_Order__c	
                                                 FROM TV_LegalTextGeneric__c
                                                 WHERE 
                                                    TV_LTG_FLG_Active__c = TRUE AND
                                                    (
                                                        (TV_LTG_SEL_Type__c   = 'INICIO' AND 
                                                        TV_LTG_SEL_Subtype__c = 'RECUPERACIONES')  
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'INICIO' AND
                                                        TV_LTG_SEL_Subtype__c = :contactPerson) 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'PERSONA' AND
                                                        TV_LTG_SEL_Subtype__c = :contactType) 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'DUALIZACIÓN' AND 
                                                        TV_LTG_SEL_Subtype__c = 'LUZ')
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'DUALIZACIÓN' AND 
                                                        TV_LTG_SEL_Subtype__c = 'GAS') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'RECUPERACIÓN' AND 
                                                        TV_LTG_SEL_Subtype__c = 'LUZ') //TODO
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'RECUPERACIÓN' AND 
                                                        TV_LTG_SEL_Subtype__c = 'GAS') //TODO
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'PROMO' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'FIN_OFERTA' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'FIN_OFERTA' AND
                                                        TV_LTG_SEL_Subtype__c = 'LUZ') 
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'EFACTURA' AND
                                                        TV_LTG_SEL_Subtype__c = :eInvoice) 
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'SPP' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'CUOTADOCE' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'FACTURACION' AND
                                                        TV_LTG_SEL_Subtype__c = '')
                                                        OR
                                                        (TV_LTG_SEL_Type__c    = 'PUNTO_SUMINISTRO' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'DISTRIBUIDORA' AND 
                                                        TV_LTG_SEL_Subtype__c = :contactPerson) 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'DERECHOS_ENDESA' AND 
                                                        TV_LTG_SEL_Subtype__c = :contactPerson) 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'BONO_SOCIAL' AND
                                                        TV_LTG_SEL_Subtype__c = '') 
                                                        OR
                                                        (TV_LTG_SEL_Type__c   = 'FIN_TXL' AND
                                                        TV_LTG_SEL_Subtype__c = '')
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'PRODUCTO' AND
                                                        TV_LTG_SEL_Subtype__c = '')
                                                        OR 
                                                        (TV_LTG_SEL_Type__c   = 'IBAN' AND
                                                        TV_LTG_SEL_Subtype__c = '')
                                                    )
                                                ORDER BY TV_LTG_NUM_Order__c ASC];

        if(listGenericTexts.isEmpty()){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun Texto Legal General.');
        }

        List<TV_LegalTextProduct__c> listProductsTexts = [  SELECT    
                                                                Id, 
                                                                TV_LTP_TXT_Text__c,
                                                                TV_LTP_SEL_Type__c,
                                                                TV_LTP_TXT_ProductCode__c
                                                            FROM TV_LegalTextProduct__c
                                                            WHERE TV_LTP_FLG_Active__c = TRUE];
        if(listProductsTexts.isEmpty()){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado ningun Texto Legal de Producto.');
        }

        Set<String> setProductTextAttributes = new Set<String>();
        for(TV_LegalTextProduct__c legalTextProduct : listProductsTexts){
            if(legalTextProduct.TV_LTP_SEL_Type__c == 'ATRIBUTO'){
                setProductTextAttributes.add(legalTextProduct.TV_LTP_TXT_ProductCode__c);
            }
        }

        Map<String, TV_LegalTextProduct__c> mapProductTexts = new Map<String, TV_LegalTextProduct__c>();
        for(TV_LegalTextProduct__c productText : listProductsTexts){
            mapProductTexts.put(productText.TV_LTP_TXT_ProductCode__c, productText);
        }                                        
        

        // Obtenemos los CIs para casos especiales/particulares
        NE__OrderItem__c ciElecRate;
        NE__OrderItem__c ciIban;
        Set<String> setSubtypes = new Set<String>();
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_SEL_RateATRTollGroup__c  != null && ci.FI_CI_SEL_Business_Line__c == '01'){
                ciElecRate = ci;
            }
            if(ci.FI_CI_LKP_PaytmenDatas__c != null && ci.FI_CI_LKP_PaytmenDatas__r.IBAN__c != null){
                ciIban = ci;
            }
            if(ci.FI_CI_SEL_Subtype__c != null){
                setSubtypes.add(ci.FI_CI_SEL_Subtype__c);
            }
        }

        if(ciIban == null){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado el método de pago en ningun ci.');
        }

        Map<String, String> genericVars = getGenericVarsMap(titularContact, authorizedContact, role.Roles, spElec, spGas); 
        Map<String, String> specialVars = getSpecialCIVarMap(ciElecRate, ciIban, setSubtypes, listCIs);
        Map<String, String> defaultPSVars = new Map<String, String>(); 

        if(spElec != null){
            defaultPSVars = getSPVarsMap(spElec);
        }  
        if(spGas != null && defaultPSVars.isEmpty()){
            defaultPSVars = getSPVarsMap(spGas);
        }       

        String genericLegalText = ''; 
        String templatePS = '';
        for(TV_LegalTextGeneric__c genericText : listGenericTexts){
            if(genericText.TV_LTG_SEL_Type__c == 'PUNTO_SUMINISTRO'){
                templatePS = genericText.TV_LTG_TXT_Text__c + '\n'; 
            }
        }
        if(String.isBlank(templatePS)){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado el Texto Legal General para el Punto de Suministro.');
        }

        Set<String> setCodeAttributes = new Set<String>();
        Set<String> setCodeAttributesAbono = new Set<String>();

        String codeAttributes = Label.TV_TXL_LIST_ATTRIBUTE_NAMES_CODE_CRM;
        String[] codeAttributesSplitted = codeAttributes.split('\\|');
        String[] setCodeAttributesSplitted = codeAttributesSplitted[0].split(';');
        String[] setCodeAttributesAbonoSplitted = codeAttributesSplitted[1].split(';');

        setCodeAttributes.addAll(setCodeAttributesSplitted);
        setCodeAttributesAbono.addAll(setCodeAttributesAbonoSplitted);

        for(TV_LegalTextGeneric__c genericText : listGenericTexts){
            if(genericText.TV_LTG_SEL_Type__c == 'INICIO' && isRecoveryCampaign){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }else if(genericText.TV_LTG_SEL_Type__c == 'INICIO'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'PERSONA'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'PRODUCTO'){
                
                // Caso televent: https://endesab2c--televent.lightning.force.com/lightning/r/NE__Quote__c/a1C3N0000015GA5UAM/view?ws=%2Flightning%2Fr%2FAccount%2F0013N00000A2qmZQAR%2Fview%3FSF__MemberID%3D00v3N0000007q1KQAQ%26SF__CampaignID%3D7013N0000001CgOQAU%26SF__LeadID%3D%26SF__ContactID%3D0033N000007SCdlQAG%26SF__AccountID%3D0013N00000A2qmZQAR%26GNS__agentid%3D%26GNS__campaignname%3DSF_TEST01%26GNS__campaignid%3D%257B5EDDC11D-FD69-4896-9B32-37F6E8E1F8BE%257D%26GNS__callidkey%3D300169718720200413%26GNS__AGRcampaign%3DRec%2520Luz%253C10
                if(spElec != null){
                    genericLegalText += getSPLegalText(spElec, listLuzCIs, mapProductTexts, mapOrderItemAttributes, mapProductCodePriceAttributes, setProductTextAttributes, setAbonoCIs, setCodeAttributes, templatePS, genericVars);
                }
                if(spGas != null){
                    genericLegalText += getSPLegalText(spGas, listGasCIs, mapProductTexts, mapOrderItemAttributes, mapProductCodePriceAttributes, setProductTextAttributes, setAbonoCIs, setCodeAttributes, templatePS, genericVars);
                }

                for(NE__OrderItem__c ci: listNoECIs){  
                    //genericLegalText += '+ ' + ci.NE__ProdName__c + '\n';
                    //genericLegalText += '- ' + mapProductTexts.get(ci.FI_CI_TXT_Product_number__c).TV_LTP_TXT_Text__c + '\n';
                    String textParent = '+ ' + mapProductTexts.get(ci.FI_CI_TXT_Product_number__c).TV_LTP_TXT_Text__c+ '\n';
                    Map<String, String> mapVarsCI = getCIVarsMap(ci, mapOrderItemAttributes.get(ci.Id), mapProductCodePriceAttributes);
                    textParent = sustituteVars(textParent, mapVarsCI);
                    genericLegalText += textParent;
                }
                genericLegalText += 'Todos los precios incluyen impuestos. Los descuentos se aplican sobre el precio base antes de impuestos.\n\n';
            }
            if(genericText.TV_LTG_SEL_Type__c == 'FIN_OFERTA' && genericText.TV_LTG_SEL_Subtype__c == ''){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'FIN_OFERTA' && genericText.TV_LTG_SEL_Subtype__c == 'LUZ' && isContractingElec){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'CUOTADOCE' && hasQuote12){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'EFACTURA' ){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'PROMO' ){
                for(NE__OrderItem__c ci: setAbonoCIs){  
                    for(String attributeName : setCodeAttributesAbono){
                        if(hasAttribute(mapOrderItemAttributes.get(ci.Id), attributeName)){
                            String code = getAttributeValue(mapOrderItemAttributes.get(ci.Id), attributeName);
                            genericLegalText += mapProductTexts.get(code).TV_LTP_TXT_Text__c + '\n';
                        }
                    }
                    //genericLegalText += '+ ' + ci.NE__ProdName__c + ':\n';
                }
            }
            if(genericText.TV_LTG_SEL_Type__c == 'IBAN'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';
            }
            if(genericText.TV_LTG_SEL_Type__c == 'FACTURACION' && genericText.TV_LTG_SEL_Subtype__c == 'LUZ' && hasDH){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';
            }
            if(genericText.TV_LTG_SEL_Type__c == 'DISTRIBUIDORA'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'DERECHOS_ENDESA'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'BONO_SOCIAL'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
            if(genericText.TV_LTG_SEL_Type__c == 'FIN_TXL'){
                String text = sustituteVars(genericText.TV_LTG_TXT_Text__c, genericVars); 
                text = sustituteVars(text, defaultPSVars);
                text = sustituteVars(text, specialVars);
                genericLegalText += text + '\n';  
            }
        }
        return genericLegalText;
    }

    public static String getLegalTextciAttributes(NE__OrderItem__c ci, Map<Id, List<NE__Order_Item_Attribute__c>> mapOrderItemAttributes, Set<String> setProductTextAttributes, Map<String, TV_LegalTextProduct__c> mapProductTexts, Map<String, String> mapVarsCI){
        String genericLegalText = '';
        for(String attributeName : setProductTextAttributes){
            if(hasAttribute(mapOrderItemAttributes.get(ci.Id), attributeName)){
                if(attributeName == 'Permanencia' && getAttributeValue(mapOrderItemAttributes.get(ci.Id), attributeName) != 'SI'){
                    continue;
                }
                if(attributeName == 'Más opciones' && getAttributeValue(mapOrderItemAttributes.get(ci.Id), attributeName) != '50 HORAS 0€ ENERGIA'){
                    continue;
                }
                String text = mapProductTexts.get(attributeName).TV_LTP_TXT_Text__c + '\n';
                text = sustituteVars(text, mapVarsCI);
                genericLegalText += text;
            }
        }
        return genericLegalText;
    }

    public static Boolean isValidPostalCode (String postalCode){
        if(postalCode.length() == 5){
            return true;
        }
        return false;
    }

    public static Boolean isIGIC (String postalCode){
        if(postalCode.length() == 5 && (postalCode.startsWith('35') || postalCode.startsWith('38'))){
            return true;
        }
        return false;
    }

    public static Boolean isIPSI (String postalCode){
        if(postalCode.length() == 5 && (postalCode.startsWith('51') || postalCode.startsWith('52'))){
            return true;
        }
        return false;
    }

    public static String sustituteVars(String text, Map<String, String> vars){
        for(String var : vars.keySet()){
            if(vars.get(var) != null){
                text = text.replace(var, vars.get(var));
            }
        }
        return text;
    }

    public static Boolean hasAttribute(List<NE__Order_Item_Attribute__c> listAttributes, String name){
        Boolean hasValue = false;
        for(NE__Order_Item_Attribute__c attribute : listAttributes){
            if(attribute.Name == name ){
                return true;
            }
        }
        return hasValue;
    }

    
    public static Boolean hasAttributeAndNotEmpty(List<NE__Order_Item_Attribute__c> listAttributes, String name){
        return hasAttribute(listAttributes, name) && String.isNotBlank(getAttributeValue(listAttributes, name));
    }

    public static String getAttributeValue(List<NE__Order_Item_Attribute__c> listAttributes, String name){
        String value = '';
        for(NE__Order_Item_Attribute__c attribute : listAttributes){
            if(attribute.Name == name ){
                return attribute.NE__Value__c;
            }
        }
        return value;
    }

    public static Map<String, String> getGenericVarsMap (Contact titular, Contact authorized, String role, B2C_Service_Point__c spLuz, B2C_Service_Point__c spGas){
        Map<String, String> mapVars = new Map<String, String>();
        mapVars.put(C + 'fecha' + C, Date.today().format());
        mapVars.put(C + 'hora' + C, Datetime.now().format('hh:mm'));
        mapVars.put(C + 'nombre_titular' + C, titular.Firstname);
        mapVars.put(C + 'apellidos_titular' + C, titular.Lastname);
        mapVars.put(C + 'dni_titular' + C, titular.NIF_CIF_Customer_NIE__c);
        mapVars.put(C + 'telefono_titular' + C, titular.MobilePhone);
        if(authorized.Physical_or_legal_cd__c == 'Physical Customer'){ 
            mapVars.put(C + 'nombre_autorizado' + C, authorized.Firstname);
            mapVars.put(C + 'apellidos_autorizado' + C, authorized.Lastname);
            mapVars.put(C + 'dni_autorizado' + C, authorized.NIF_CIF_Customer_NIE__c);
        }else if(authorized.Physical_or_legal_cd__c == 'Corportate Customer'){
            mapVars.put(C + 'cargo_empresa' + C, role);
            mapVars.put(C + 'nombre_empresa' + C, authorized.Lastname);
            mapVars.put(C + 'cif_empresa' + C, authorized.NIF_CIF_Customer_NIE__c);
        }
        return mapVars;
    }

    public static Map<String, String> getSpecialCIVarMap(NE__OrderItem__c ciElec, NE__OrderItem__c ciIban, Set<String> subtypes, List<NE__OrderItem__c> listCIs){
        Map<String, String> mapVars = new Map<String, String>();
        if(ciElec != null){
            mapVars.put(C + 'txl_tarifa_luz' + C, ciElec.FI_CI_SEL_RateATRTollGroup__c ); 
        }
        if(ciIban != null){
            mapVars.put(C + 'iban' + C, ciIban.FI_CI_LKP_PaytmenDatas__r.IBAN__c);
        }
        String modificationType = '';
        Boolean first = true;
        for(String subtype : subtypes){
            if(!first){
                modificationType += ', ';
            }
            modificationType += subtype;
            first = false;
        }
        if(String.isNotBlank(modificationType)){
            mapVars.put(C + 'tipo_ad_cc_ct' + C, modificationType);
        }

        mapVars.put(C + 'y_servicio' + C, '');
        first = true;
        String listProducts = '';
        Boolean hasElec = false;
        Boolean hasGas = false;
        for(NE__OrderItem__c ci: listCIs){
            if(ci.FI_CI_SEL_Business_Line__c == '01'){
                hasElec = true;
            }
            if(ci.FI_CI_SEL_Business_Line__c == '02'){
                hasGas = true;
            }
            if(ci.FI_CI_SEL_Business_Line__c == '03' || ci.FI_CI_SEL_Business_Line__c == '04'){
                mapVars.put(C + 'y_servicio' + C, 'y servicios');
            }
            if(!first){
                listProducts += ', ';
            }
            listProducts += ci.NE__ProdName__c;
            first = false;
        }
        if(String.isNotBlank(listProducts)){
            mapVars.put(C + 'lista_productos_servicios' + C, listProducts);
        }
        if(hasElec && hasGas){
            mapVars.put(C + 'luz_gas' + C, 'luz y gas'); 
        }else if(hasElec){
            mapVars.put(C + 'luz_gas' + C, 'luz'); 
        }else if(hasGas){
            mapVars.put(C + 'luz_gas' + C, 'gas');
        }
        return mapVars;
    }

    public static Map<String, String> getCIVarsMap(NE__OrderItem__c ci, List<NE__Order_Item_Attribute__c > listAttribute, Map<String, Map<String, FI_CongaParametrization__c>> mapProductCodePriceAttributes){
        Map<String, String> mapVars = new Map<String, String>();
        if(hasAttribute(listAttribute, 'Tipo Descuento')){
            mapVars.put(C + 'descripcion_descuento' + C, getAttributeValue(listAttribute, 'Tipo Descuento'));
        }
        if(hasAttributeAndNotEmpty(listAttribute, 'DIA')){
            mapVars.put(C + 'rango_happy' + C, 'donde el termino de energía tendrá precio 0 € [los ' + getAttributeValue(listAttribute, 'DIA') + '], siendo este el periodo Happy que Ud. ha seleccionado.');
        }else if(hasAttributeAndNotEmpty(listAttribute, 'HORAS')){
            mapVars.put(C + 'rango_happy' + C, 'donde el termino de energía tendrá precio 0 € [de ' + getAttributeValue(listAttribute, 'HORAS') + '], siendo este el periodo Happy que Ud. ha seleccionado.');
        }else{
            mapVars.put(C + 'rango_happy' + C, ' ');
        }

        if(mapProductCodePriceAttributes != null && mapProductCodePriceAttributes.containsKey(ci.FI_CI_TXT_Product_number__c)){
            String price = '';
            for(FI_CongaParametrization__c priceAttribute : mapProductCodePriceAttributes.get(ci.FI_CI_TXT_Product_number__c).values()){
                for(NE__Order_Item_Attribute__c attribute : listAttribute){
                    if(priceAttribute.FI_COP_TXT_Conga_Real_Name__c == attribute.Name && String.isNotBlank(attribute.NE__Value__c)){
                        String priceWithTax = calculatePriceWithTaxes(ci, attribute.Name, attribute.NE__Value__c);
                        price += '\n' + priceAttribute.FI_COP_TXT_Conga_Commercial_Name__c + '\nSin impuestos: ' + attribute.NE__Value__c + '\nCon impuestos: ' + priceWithTax;
                    }
                }
            }
            if(String.isNotBlank(price)){
                mapVars.put(C + 'precio' + C, price);
            }
        }else if(hasAttribute(listAttribute, 'Precio mensual (impuestos no incluidos)')){
            String price = getAttributeValue(listAttribute, 'Precio mensual (impuestos no incluidos)');
            String priceWithTax = calculatePriceWithTaxes(ci, 'Precio mensual (impuestos no incluidos)', price);
            mapVars.put(C + 'precio' + C, 'Precio mensual [€]:\nSin impuestos: ' + price + '\nCon impuestos: ' + priceWithTax);
        }

        return mapVars; 
    }

    public static Decimal maxPower (List<Decimal> listPowers){
        Decimal maxPower = 0;
        for(Decimal power : listPowers){
            if(power > maxPower){
                maxPower = power;
            }
        }
        return maxPower;
    }

    public static String calculatePriceWithTaxes (NE__OrderItem__c ci, String priceName, String priceValue){
        Decimal value = Decimal.valueOf(priceValue);
        if(ci.FI_CI_LKP_CUPS__c == null){
            throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado el punto de suministro de un CI');   
        }

        String postalCode = ci.FI_CI_LKP_CUPS__r.PostalCode__c;
        if(!isValidPostalCode(postalCode)){
            throw new LegalTextException('Error al generar Texto Legal. El código postal no es válido en el punto de suministro de un CI');   
        }

        if(ci.FI_CI_SEL_Business_Line__c == '01'){
            value = value * ELECTRICITY_TAX;
            List<Decimal> listPowers = new List<Decimal>{ci.FI_CI_NUM_PowerToHire1kW__c, ci.FI_CI_NUM_PowerToHire2kW__c, ci.FI_CI_NUM_PowerToHire3kW__c};
            if(isIGIC(postalCode) && maxPower(listPowers) > 10){
                value = value * IGIC;
            }else if(isIPSI(postalCode)){
                value = value * IPSI;
            }else{
                value = value * IVA;
            }
        }else if(ci.FI_CI_SEL_Business_Line__c == '02'){
            if(priceName.containsIgnoreCase(' TV') && priceName.containsIgnoreCase('€/kWh')){
                value = value + GAS_TAX;
            }
            if(isIGIC(postalCode)){
                value = value * IGIC;
            }else if(isIPSI(postalCode)){
                value = value * IPSI;
            }else{
                value = value * IVA;
            }
        }else{
            if(isIGIC(postalCode)){
                value = value * IGIC;
            }else if(isIPSI(postalCode)){
                value = value * IPSI;
            }else{
                value = value * IVA;
            }
        }
        value = value.setScale(6, System.RoundingMode.FLOOR);
        return String.valueOf(value);
    }

    public static Map<String, String> getSPVarsMap(B2C_Service_Point__c sp){
        Map<String, String> mapVars = new Map<String, String>();
        mapVars.put(C + 'direccion_suministro' + C, sp.Adress__c);
        mapVars.put(C + 'cups_luz' + C, '');
        mapVars.put(C + 'cups_gas' + C, '');
        if(sp.Business_line_cd__c == '01'){
            mapVars.put(C + 'cups_luz' + C, sp.Name);
            mapVars.put(C + 'distribuidora' + C, sp.DistribuitorElec_cd__c);
        }else if(sp.Business_line_cd__c == '02'){
            mapVars.put(C + 'cups_gas' + C, sp.Name);
            mapVars.put(C + 'distribuidora' + C, sp.DistribuitorGas_cd__c);
        }
        mapVars.put(C + 'distribuidora_luz' + C, sp.DistribuitorElec_cd__c);
        mapVars.put(C + 'distribuidora_gas' + C, sp.DistribuitorGas_cd__c);
        if(sp.CNAE__r.Segment__c.equalsIgnoreCase('Doméstico')){
            mapVars.put(C + 'domestico_pn' + C, 'Doméstico'); 
        }else{
            mapVars.put(C + 'domestico_pn' + C, 'Pequeño Negocio'); 
        }
        return mapVars;
    }

    public static String getSPLegalText(B2C_Service_Point__c servicePoint, List<NE__OrderItem__c> listCIs, Map<String, TV_LegalTextProduct__c> mapProductTexts, Map<Id, List<NE__Order_Item_Attribute__c>> mapOrderItemAttributes, Map<String, Map<String, FI_CongaParametrization__c>> mapProductCodePriceAttributes, Set<String> setProductTextAttributes, List<NE__OrderItem__c> setAbonoCIs, Set<String> setCodeAttributes, String templatePS, Map<String, String> genericVars){
        String legalText = '';
        for(NE__OrderItem__c ci: listCIs){  
            if(!mapProductTexts.containsKey(ci.FI_CI_TXT_Product_number__c)){
                throw new LegalTextException('Error al generar Texto Legal. No se ha encontrado el Texto Legal de Producto: ' + ci.FI_CI_TXT_Product_number__c);
            }
            String textParent = '+ ' + mapProductTexts.get(ci.FI_CI_TXT_Product_number__c).TV_LTP_TXT_Text__c+ '\n';
            Map<String, String> mapVarsCI = getCIVarsMap(ci, mapOrderItemAttributes.get(ci.Id), mapProductCodePriceAttributes);
            textParent = sustituteVars(textParent, mapVarsCI);
            legalText += textParent;
            legalText += getLegalTextciAttributes(ci, mapOrderItemAttributes, setProductTextAttributes, mapProductTexts, mapVarsCI);
            
            for(NE__OrderItem__c childCI : ci.NE__Parent_Order_Item__r){  
                Map<String, String> mapVarsChildCi = getCIVarsMap(childCI, mapOrderItemAttributes.get(childCI.Id), null);
                if(setAbonoCIs.contains(childCI)){  
                    continue;
                }
                for(String attributeName : setCodeAttributes){
                    if(hasAttribute(mapOrderItemAttributes.get(childCI.Id), attributeName)){
                        String code = getAttributeValue(mapOrderItemAttributes.get(childCI.Id), attributeName);
                        if(String.isNotBlank(code)){
                            String text = mapProductTexts.get(code).TV_LTP_TXT_Text__c + '\n';
                            text = sustituteVars(text, mapVarsChildCi);
                            legalText += text;
                        }
                    }
                }

                legalText += getLegalTextciAttributes(childCI, mapOrderItemAttributes, setProductTextAttributes, mapProductTexts, mapVarsChildCi);

            }

        }

        // PS Text 
        String template = templatePS;
        String text = sustituteVars(template, genericVars) + '\n'; 
        text = sustituteVars(text, getSPVarsMap(servicePoint));
        legalText += text;

        return legalText;
    }

    public static Id createTemporalRecord(String caseId, String text){
        if (!Schema.sObjectType.TV_CongaTemporalLegalText__c.IsCreateable()){
            throw new LegalTextException('Error al generar Texto Legal. Configuración incorrecta: No hay permiso para el objeto temporal de Conga');   
        }
        TV_CongaTemporalLegalText__c temporalRecord = new TV_CongaTemporalLegalText__c();
        temporalRecord.TV_LTT_TXT_ParentId__c = caseId;
        temporalRecord.TV_LTT_TXT_Text__c     = text;
        insert temporalRecord;
        return temporalRecord.Id;
    }

    public static String getUrlConga(String caseId, String temporalRecordId){
        if (!Schema.sObjectType.APXTConga4__Conga_Template__c.isAccessible()
            || !Schema.sObjectType.APXTConga4__Conga_Merge_Query__c.isAccessible()){
            throw new LegalTextException('Error al generar Texto Legal. Configuración incorrecta: No hay permiso para los objectos de Conga');   
        }

        List<APXTConga4__Conga_Template__c> listTemplates = [SELECT Id, APXTConga4__Name__c FROM APXTConga4__Conga_Template__c WHERE APXTConga4__Name__c  = 'TV_TextoLegal'];       
        String filename = ('Texto legal ' + Datetime.now().format('dd-MM-yyyy')).replace(' ', '+');        
        if(listTemplates.isEmpty()){
            throw new LegalTextException('Error al generar URL de Conga. Falta template.');
        }
        List<APXTConga4__Conga_Merge_Query__c> listQueries = [SELECT Id FROM APXTConga4__Conga_Merge_Query__c WHERE FI_COQ_TXT_ExternalId__c = 'tvlt'];
        if(listQueries.isEmpty()){
            throw new LegalTextException('Error al generar URL de Conga. Falta query.');
        }
        
        String url = String.valueOf(System.URL.getOrgDomainUrl().toExternalForm()) +'/apex/APXTConga4__Conga_Composer?'+
        '?SessionId={!API.Session_ID}'+
        '&serverUrl={!API.Partner_Server_URL_370}'+
        '&ds7=5&fp0=1&id=' + caseId +
        '&queryid='+'[tvlt]'+listQueries[0].Id+'?ltt='+ temporalRecordId +','+ 
        '&sc0=1'+
        '&templateid='+listTemplates[0].Id+'&SC1=SalesforceFile&OFN='+filename+
        '&ReturnPath=lightning/cmp/c__FI_LC_WindowCloser';

        return url;
    }

    public class LegalTextWrapper {
        @AuraEnabled
        public String legalText;
        @AuraEnabled
        public String urlCongaPDF;
        @AuraEnabled
        public String error;
    }


}